!*****************************************************************************!
!* 
!*      $RCSfile: PrimCons.f90,v $
!*
!*      $Revision: 1.2 $
!*
!*      $Date: 2003/12/11 14:46:59 $
!*
!*      $Author: roller $
!*
!*****************************************************************************!

MODULE PrimCons_mod
  !---------------------------------------------------------------------------!
  IMPLICIT NONE
  PRIVATE
  !---------------------------------------------------------------------------!
  INTERFACE PrimCons
     MODULE PROCEDURE PrimCons
  END INTERFACE
  !---------------------------------------------------------------------------!
  PUBLIC  :: PrimCons
  !---------------------------------------------------------------------------!

CONTAINS

  SUBROUTINE PrimCons(iflag,pvar,cvar,Const,Mesh)
    USE Types
    !---------------------------------------------------------------------------!
    IMPLICIT NONE
    !---------------------------------------------------------------------------!
    ! Argument list declaration
    TYPE(tConstants)        :: Const
    TYPE(tMesh)             :: Mesh
    INTEGER                 :: iflag
    REAL                    :: pvar(0:Mesh%IMAX+1,0:Mesh%JMAX+1,Const%nvar)
    REAL                    :: cvar(0:Mesh%IMAX+1,0:Mesh%JMAX+1,Const%nvar)
    ! Local variable declaration
    REAL                    :: gamm1, gamma1q
    !---------------------------------------------------------------------------!
    INTENT(IN)              :: iflag, Const, Mesh
    INTENT(INOUT)             :: pvar, cvar
    !---------------------------------------------------------------------------!

    gamm1   = Const%gamma - 1.0
    gamma1q = 1.0 / gamm1

    SELECT CASE(iflag)
    CASE(1)                    ! (1) conservative to primitive transformation
       
       pvar(:,:,1) =                                 ! density (rho)
       pvar(:,:,2) =                                 ! x-velocity (u)
       pvar(:,:,3) =                                 ! y-velocity (v)
       pvar(:,:,4) = 

                                                   ! pressure (p)
       
       ! check if density and pressure are negative
       WHERE ( pvar(:,:,1) < 1.e-10 )
          pvar(:,:,1) = 1.e-10
       END WHERE
       WHERE ( pvar(:,:,4) < 1.e-10 )
          pvar(:,:,4) = 1.e-10
       END WHERE
       
       
    CASE(2)                    ! (2) primitive to conservative transformation
       
       cvar(:,:,1) =                                ! density
       cvar(:,:,2) =                                ! x-momentum
       cvar(:,:,3) =                                ! y-momentum
       cvar(:,:,4) = 

                                                         ! total energy
       
    CASE DEFAULT
    
       PRINT *, 'ERROR PrimCons : Wrong direction flag for conversion.  '
       PRINT *, 'Use (1) for cons -> prim and (2) for prim -> cons.     '
       STOP
   
    END SELECT
    
  END SUBROUTINE PrimCons


END MODULE PrimCons_mod
